package do

import (
	"PaymentCenter/app/constants/common"
	"PaymentCenter/app/third/paymentService"
	"github.com/bytedance/sonic"
)

var PayWayList = map[int]func(commonPayInfo *paymentService.PayOrderRequest, ExtJson string) error{
	common.PAY_CHANNEL_WECHAT_H5:  WechatH5,
	common.PAY_CHANNEL_ALIPAY_WEB: AlipayWeb,
}

func WechatH5(commonPayInfo *paymentService.PayOrderRequest, ExtJson string) error {
	err := sonic.Unmarshal([]byte(ExtJson), &commonPayInfo.Wx)
	if err != nil {
		return err
	}
	return nil
}

func AlipayWeb(commonPayInfo *paymentService.PayOrderRequest, ExtJson string) error {
	err := sonic.Unmarshal([]byte(ExtJson), &commonPayInfo.Ali)
	if err != nil {
		return err
	}
	return nil
}
